Contributing to oc-id
===========================
Thanks for your interest in contributing to oc-id!

The basic process:
* Sign a Chef CLA (see below)
* Create a git topic branch for your patch and push it to GitHub
* Open a pull request

The Apache License and Chef Contributor License Agreements
-----------------------------------------------------------
Licensing is very important to open source projects, it helps ensure the software continues to be available under the terms that the author desired.
Chef uses the Apache 2.0 license to strike a balance between open contribution and allowing you to use the software however you would like to.

The license tells you what rights you have that are provided by the copyright holder. It is important that the contributor fully understands what rights
they are licensing and agrees to them. Sometimes the copyright holder isn't the contributor, most often when the contributor is doing work for a company.

To make a good faith effort to ensure these criteria are met, Chef requires a Contributor License Agreement (CLA) or a Corporate Contributor License
Agreement (CCLA) for all contributions. This is without exception due to some matters not being related to copyright and to avoid having to continually
check with our lawyers about small patches.

It only takes a few minutes to complete a CLA, and you retain the copyright to your contribution.

You can [become a contributor by signing the ICLA or by contributing on behalf of your company](http://supermarket.chef.io/become-a-contributor).

For more information about licensing, copyright, and CLAs see Chef's [Community Contributions](http://docs.chef.io/community_contributions.html) page.

Working with the community
--------------------------
These resources will help you learn more about Chef and connect to other members of the Chef community:

* [chef](http://lists.chef.io/sympa/info/chef) and [chef-dev](http://lists.chef.io/sympa/info/chef-dev) mailing lists
* #chef and #chef-hacking IRC channels on irc.freenode.net
* [Chef docs](http://docs.chef.io)
* Chef [product page](http://www.chef.io/chef)


Overview
--------
If you're experienced with the toolchain, here are the steps for submitting a patch to oc-id:

1. [Fork the project](https://github.com/opscode/oc-id/fork) on GitHub
1. Create a feature branch:

        $ git checkout -b my_feature

1. Make your changes, writing excellent commit messages and adding appropiate test coverage
1. Open a [Pull Request](https://github.com/opscode/oc-id/pull) against the oc-id master branch on GitHub

